unit spanrpt;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  QuickRpt, Qrctrls, Db, DBTables, ExtCtrls;

const
  OtherColor = $0083D88F;

type
  TfrmSpanRpt = class(TForm)
    QuickRep1: TQuickRep;
    DetailBand1: TQRBand;
    QRSubDetail1: TQRSubDetail;
    QRSubDetail2: TQRSubDetail;
    CustomerTb: TTable;
    QRDBText1: TQRDBText;
    QRDBText2: TQRDBText;
    QRDBText3: TQRDBText;
    QRDBText4: TQRDBText;
    QRDBText5: TQRDBText;
    QRDBText6: TQRDBText;
    QRDBText7: TQRDBText;
    QRDBText8: TQRDBText;
    QRDBText9: TQRDBText;
    QRDBText10: TQRDBText;
    QRDBText11: TQRDBText;
    QRBand1: TQRBand;
    PageHeader: TQRBand;
    PageHeaderLeft: TQRChildBand;
    QRBand2: TQRBand;
    PageHeaderRight: TQRChildBand;
    QRLabel11: TQRLabel;
    QRLabel10: TQRLabel;
    QRLabel9: TQRLabel;
    QRLabel8: TQRLabel;
    QRLabel7: TQRLabel;
    QRLabel1: TQRLabel;
    QRLabel2: TQRLabel;
    QRLabel3: TQRLabel;
    QRLabel4: TQRLabel;
    QRLabel5: TQRLabel;
    QRLabel6: TQRLabel;
    WhichSideQRL: TQRLabel;
    PageNumQrl: TQRLabel;
    QRSysData1: TQRSysData;
    procedure QuickRep1BeforePrint(Sender: TCustomQuickRep;
      var PrintReport: Boolean);
    procedure PageHeaderBeforePrint(Sender: TQRCustomBand;
      var PrintBand: Boolean);
    procedure PageHeaderLeftBeforePrint(Sender: TQRCustomBand;
      var PrintBand: Boolean);
    procedure QRBand1BeforePrint(Sender: TQRCustomBand;
      var PrintBand: Boolean);
    procedure QRBand2BeforePrint(Sender: TQRCustomBand;
      var PrintBand: Boolean);
    procedure PageHeaderRightBeforePrint(Sender: TQRCustomBand;
      var PrintBand: Boolean);
    procedure QRSubDetail1BeforePrint(Sender: TQRCustomBand;
      var PrintBand: Boolean);
  private
    { Private declarations }
    MyPageNumber : integer;
  public
    { Public declarations }
    ChangeColor : boolean;
  end;

var
  frmSpanRpt: TfrmSpanRpt;

implementation

{$R *.DFM}

procedure TfrmSpanRpt.QuickRep1BeforePrint(Sender: TCustomQuickRep;
  var PrintReport: Boolean);
begin
  // First, size the detail band out of the way
  DetailBand1.height := 0;

  // Then reset the page headers by using the tag property.
  PageHeaderLeft.Tag := 0;

  // The reset the new page number
  MyPageNumber := 0;

  // reset the band colors
  QRSubDetail1.Color := clWhite;
  QRSubDetail2.Color := clWhite;
end;

procedure TfrmSpanRpt.PageHeaderBeforePrint(Sender: TQRCustomBand;
  var PrintBand: Boolean);
begin
  if PageHeaderLeft.Tag = 0 then
    WhichSideQRL.Caption := 'Left side'
  else
    WhichSideQRL.Caption := 'Right side';

  inc(MyPageNumber);

  PageNumQrl.Caption := format('Page %d', [MyPageNumber]); 
end;

procedure TfrmSpanRpt.PageHeaderLeftBeforePrint(Sender: TQRCustomBand;
  var PrintBand: Boolean);
begin
  PrintBand := PageHeaderLeft.Tag = 0;
end;

procedure TfrmSpanRpt.QRBand1BeforePrint(Sender: TQRCustomBand;
  var PrintBand: Boolean);
begin
  // we use this band to force a new page, but we don't to print it.
  quickrep1.NewPage;
  PrintBand := false;
end;

procedure TfrmSpanRpt.QRBand2BeforePrint(Sender: TQRCustomBand;
  var PrintBand: Boolean);
begin
  // we use this band to change the page headers, but we don't need to print
  // it.  We also use it to reset the page number
  PrintBand := false;
  PageHeaderLeft.Tag := 1;
  MyPageNumber := 0;
end;

procedure TfrmSpanRpt.PageHeaderRightBeforePrint(Sender: TQRCustomBand;
  var PrintBand: Boolean);
begin
  PrintBand := PageHeaderLeft.Tag = 1;
end;

procedure TfrmSpanRpt.QRSubDetail1BeforePrint(Sender: TQRCustomBand;
  var PrintBand: Boolean);
begin
  // if the user wanted to print with alternating colors, here is one method
  // of doing so
  if ChangeColor then
    if Sender.Color = clWhite then
      Sender.Color := OtherColor
    else
      Sender.Color := clWhite
end;

end.
